SystemOrganization addCategory: #'Recommendations-UI'!

!OBCodeBrowser methodsFor: '*Recommendations-UI' stamp: 'AndyKellens 9/27/2012 13:46'!
browseCuriosities
	<command>
	
	^ OBCuriositiesPropertiesCommand  ! !

!OBCodeBrowser methodsFor: '*Recommendations-UI' stamp: 'AndyKellens 9/27/2012 13:46'!
browseMissing
	<command>
	
	^ OBMissingPropertiesCommand  ! !

OBCommand subclass: #OBCuriositiesPropertiesCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Recommendations-UI'!

!OBCuriositiesPropertiesCommand methodsFor: 'accessing' stamp: 'AndyKellens 9/27/2012 16:04'!
cluster
	^#'Recommendations'! !

!OBCuriositiesPropertiesCommand methodsFor: 'execution' stamp: 'AndyKellens 9/27/2012 13:45'!
execute
	OBCuriositiesPropertiesBrowser openRoot: target copy! !

!OBCuriositiesPropertiesCommand methodsFor: 'accessing' stamp: 'AndyKellens 9/27/2012 16:04'!
group 
	^#general! !

!OBCuriositiesPropertiesCommand methodsFor: 'testing' stamp: 'AndyKellens 9/27/2012 16:10'!
isActive
	^ (target isKindOf: OBClassNode) or:[target isKindOf: OBMethodNode]! !

!OBCuriositiesPropertiesCommand methodsFor: 'accessing' stamp: 'AndyKellens 9/27/2012 13:45'!
label 
	^'Curiosities'! !

!OBCuriositiesPropertiesCommand methodsFor: 'testing' stamp: 'AndyKellens 9/27/2012 13:44'!
wantsButton
	^true! !

OBCommand subclass: #OBMissingPropertiesCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Recommendations-UI'!

!OBMissingPropertiesCommand methodsFor: 'accessing' stamp: 'AndyKellens 9/27/2012 16:04'!
cluster
	^#'Recommendations'! !

!OBMissingPropertiesCommand methodsFor: 'execution' stamp: 'AndyKellens 9/27/2012 13:41'!
execute
	OBMissingPropertiesBrowser openRoot: target copy! !

!OBMissingPropertiesCommand methodsFor: 'accessing' stamp: 'AndyKellens 9/27/2012 16:03'!
group 
	^#general! !

!OBMissingPropertiesCommand methodsFor: 'testing' stamp: 'AndyKellens 9/27/2012 16:10'!
isActive
	^ (target isKindOf: OBClassNode) or:[target isKindOf: OBMethodNode]! !

!OBMissingPropertiesCommand methodsFor: 'accessing' stamp: 'AndyKellens 9/27/2012 13:42'!
label 
	^'Missing'! !

!OBMissingPropertiesCommand methodsFor: 'testing' stamp: 'AndyKellens 9/27/2012 10:39'!
wantsButton
	^true! !

!OBClassAwareNode methodsFor: '*Recommendations-UI' stamp: 'AndyKellens 9/27/2012 14:16'!
missing
	^RecommendationsFacade missingForEntity: (self recommendationEntity)! !

!OBClassAwareNode methodsFor: '*Recommendations-UI' stamp: 'AndyKellens 9/27/2012 11:44'!
recommendationEntity
	^theClass! !

!OBClassAwareNode methodsFor: '*Recommendations-UI' stamp: 'AndyKellens 9/27/2012 15:19'!
suggested
	^ RecommendationsFacade suggestedForEntity: (self recommendationEntity).
	! !

OBBrowser subclass: #OBCuriositiesPropertiesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Recommendations-UI'!

!OBCuriositiesPropertiesBrowser class methodsFor: 'configuration' stamp: 'AndyKellens 9/27/2012 13:45'!
defaultMetaNode
	| root suggested rules |
	root := OBMetaNode named: 'Recommendations'.
	suggested := OBMetaNode named: 'curiosities'.
	rules := OBMetaNode named:'rules'.
	root childAt:#suggested put: suggested.
	suggested childAt:#rules put: rules.
	^ root! !

!OBCuriositiesPropertiesBrowser class methodsFor: 'configuration' stamp: 'AndyKellens 9/27/2012 13:44'!
panels 
	^OrderedCollection with:(self recommendationsPanel)! !

!OBCuriositiesPropertiesBrowser class methodsFor: 'configuration' stamp: 'AndyKellens 9/27/2012 13:44'!
recommendationsPanel
	^OBColumnPanel minPanes: 2 maxPanes: 2! !

!OBCuriositiesPropertiesBrowser class methodsFor: 'configuration' stamp: 'AndyKellens 9/27/2012 13:46'!
title 
	^'Curiosities'! !

OBBrowser subclass: #OBMissingPropertiesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Recommendations-UI'!

!OBMissingPropertiesBrowser class methodsFor: 'configuration' stamp: 'AndyKellens 9/27/2012 13:42'!
defaultMetaNode
	| root missing rules |
	root := OBMetaNode named: 'Recommendations'.
	missing := OBMetaNode named: 'missing'.
	rules := OBMetaNode named:'rules'.
	root childAt:#missing put: missing.
	missing childAt:#rules put: rules.
	^ root! !

!OBMissingPropertiesBrowser class methodsFor: 'configuration' stamp: 'AndyKellens 9/27/2012 10:34'!
panels 
	^OrderedCollection with:(self recommendationsPanel)! !

!OBMissingPropertiesBrowser class methodsFor: 'configuration' stamp: 'AndyKellens 9/27/2012 13:41'!
recommendationsPanel
	^OBColumnPanel minPanes: 2 maxPanes: 2! !

!OBMissingPropertiesBrowser class methodsFor: 'configuration' stamp: 'AndyKellens 9/27/2012 13:41'!
title 
	^'Missing'! !

!OBMethodNode methodsFor: '*recommendations-ui' stamp: 'AndyKellens 9/27/2012 11:45'!
recommendationEntity
	^theClass >> selector! !

OBNode subclass: #OAbstractRecommendationNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Recommendations-UI'!

OAbstractRecommendationNode subclass: #OBAbstractRecommendationNodeWithProperty
	instanceVariableNames: 'property applicableRules toolName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Recommendations-UI'!

!OBAbstractRecommendationNodeWithProperty class methodsFor: 'instance creation' stamp: 'AndyKellens 9/27/2012 15:15'!
property: aProperty rules: aCollection fromTool: aToolName
	^super new property: aProperty; applicableRules: aCollection; toolName: aToolName! !

!OBAbstractRecommendationNodeWithProperty methodsFor: 'accessing' stamp: 'AndyKellens 9/27/2012 14:16'!
applicableRules
	^ applicableRules! !

!OBAbstractRecommendationNodeWithProperty methodsFor: 'accessing' stamp: 'AndyKellens 9/27/2012 14:16'!
applicableRules: anObject
	applicableRules := anObject! !

!OBAbstractRecommendationNodeWithProperty methodsFor: 'accessing' stamp: 'AndyKellens 9/27/2012 15:15'!
name 
	^property asString,' (', toolName asString, ')'! !

!OBAbstractRecommendationNodeWithProperty methodsFor: 'accessing' stamp: 'AndyKellens 9/27/2012 11:38'!
property
	^ property! !

!OBAbstractRecommendationNodeWithProperty methodsFor: 'accessing' stamp: 'AndyKellens 9/27/2012 11:38'!
property: anObject
	property := anObject! !

!OBAbstractRecommendationNodeWithProperty methodsFor: 'accessing' stamp: 'AndyKellens 9/27/2012 14:37'!
rules
	^self applicableRules collect:[:each | OBRuleNode rule: each]! !

!OBAbstractRecommendationNodeWithProperty methodsFor: 'accessing' stamp: 'AndyKellens 9/27/2012 15:15'!
toolName
	^ toolName! !

!OBAbstractRecommendationNodeWithProperty methodsFor: 'accessing' stamp: 'AndyKellens 9/27/2012 15:15'!
toolName: anObject
	toolName := anObject! !

OBAbstractRecommendationNodeWithProperty subclass: #OBMissingNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Recommendations-UI'!

OBAbstractRecommendationNodeWithProperty subclass: #OBSuggestedNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Recommendations-UI'!

OBNode subclass: #OBRuleNode
	instanceVariableNames: 'rule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Recommendations-UI'!

!OBRuleNode class methodsFor: 'instance creation' stamp: 'AndyKellens 9/27/2012 14:33'!
rule: aRule
	^super new rule: aRule! !

!OBRuleNode methodsFor: 'accessing' stamp: 'AndyKellens 9/27/2012 14:36'!
name
	^rule asString! !

!OBRuleNode methodsFor: 'accessing' stamp: 'AndyKellens 9/27/2012 14:29'!
rule
	^ rule! !

!OBRuleNode methodsFor: 'accessing' stamp: 'AndyKellens 9/27/2012 14:29'!
rule: anObject
	rule := anObject! !

Object subclass: #RecommendationsFacade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Recommendations-UI'!

!RecommendationsFacade class methodsFor: 'framework' stamp: 'AndyKellens 9/27/2012 11:12'!
getMissingForEntity: anEntity
	self subclassResponsibility ! !

!RecommendationsFacade class methodsFor: 'framework' stamp: 'AndyKellens 9/27/2012 11:13'!
getSuggestedForEntity: anEntity
	self subclassResponsibility ! !

!RecommendationsFacade class methodsFor: 'interface' stamp: 'AndyKellens 9/27/2012 11:10'!
missingForEntity: anEntity
	| missing |
	missing := OrderedCollection new.
	self subclasses do:[:each | missing addAll: (each getMissingForEntity: anEntity)].
	^missing! !

!RecommendationsFacade class methodsFor: 'interface' stamp: 'AndyKellens 9/27/2012 11:10'!
suggestedForEntity: anEntity
	| suggested |
	suggested := OrderedCollection new.
	self subclasses do:[:each | suggested addAll: (each getSuggestedForEntity: anEntity)].
	^suggested! !
